 
/****************************************************************************
  SECTION 	Include
****************************************************************************/

#include "TCPIP Stack/TCPIP.h"
extern APP_CONFIG    WFConf[];
extern double        temperature;
extern unsigned long input;
extern int 	         output;
extern char 		 app_ver[6];
extern char 		 app_date[11];


typedef struct  {
  char ip[16];
  char nm[16]; 
  char gw[16];
  char ssid[30];
  BYTE mode;
  BYTE sec;
  char key[30];
} WEB_SETUP;

WEB_SETUP WEBconf;
BYTE      WEBcmd;


#if defined(STACK_USE_HTTP2_SERVER)




/****************************************************************************
  SECTION	Define
****************************************************************************/
#define __HTTPAPP_C


/****************************************************************************
  SECTION 	Authorization Handlers
****************************************************************************/
 

/*****************************************************************************
  FUNCTION	BYTE HTTPNeedsAuth(BYTE* cFile)

  This function is used by the stack to decide if a page is access protected.
  If the function returns 0x00, the page is protected, if returns 0x80, no 
  authentication is required
*****************************************************************************/
#if defined(HTTP_USE_AUTHENTICATION)
BYTE HTTPNeedsAuth(BYTE* cFile)
{
	//	If you want to restrict the access to some page, include it in the folder "protect"
	//	here you can change the folder, or add others
	if(memcmppgm2ram(cFile, (ROM void*)"protect", 7) == 0)
		return 0x00;		// Authentication will be needed later

	// You can match additional strings here to password protect other files.
	// You could switch this and exclude files from authentication.
	// You could also always return 0x00 to require auth for all files.
	// You can return different values (0x00 to 0x79) to track "realms" for below.

	return 0x80;			// No authentication required
}
#endif

/*****************************************************************************
  FUNCTION	BYTE HTTPCheckAuth(BYTE* cUser, BYTE* cPass)
	
  This function checks if username and password inserted are acceptable

  ***************************************************************************/
#if defined(HTTP_USE_AUTHENTICATION)
BYTE HTTPCheckAuth(BYTE* cUser, BYTE* cPass)
{
	if(strcmppgm2ram((char *)cUser,(ROM char *)"admin") == 0
		&& strcmppgm2ram((char *)cPass, (ROM char *)"flyport") == 0)
		return 0x80;		// We accept this combination
	
	// You can add additional user/pass combos here.
	// If you return specific "realm" values above, you can base this 
	//   decision on what specific file or folder is being accessed.
	// You could return different values (0x80 to 0xff) to indicate 
	//   various users or groups, and base future processing decisions
	//   in HTTPExecuteGet/Post or HTTPPrint callbacks on this value.
	
	return 0x00;			// Provided user/pass is invalid
}
#endif

/****************************************************************************
  SECTION	GET/POST Form Handlers
****************************************************************************/
  
/****************************************************************************
  FUNCTION	HTTP_IO_RESULT HTTPExecuteGet(void)
	
  This function processes every GET request from the pages.
*****************************************************************************/
HTTP_IO_RESULT HTTPExecuteGet(void) {
  BYTE *ptr;
  BYTE filename[20];
  char value[50];
  
  //char line;
  
  MPFSGetFilename(curHTTP.file, filename, 20);
  if(!memcmppgm2ram(filename, "save.cgi", 9)){
    //LAN
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"ip");
    if(ptr) {
      sprintf(WEBconf.ip, "%s",ptr);
    }
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"nm");
    if(ptr) {
      sprintf(WEBconf.nm, "%s",ptr);
    }
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"gw");
    if(ptr) {
      sprintf(WEBconf.gw, "%s",ptr);
    }
    //wi-fi
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"ssid");
    if(ptr) {
      sprintf(WEBconf.ssid, "%s",ptr);
    }
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"mode");
    if(ptr) {
      sprintf(value, "%s",ptr);
      WEBconf.mode=atoi(value);
    }
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"sec");
    if(ptr) {
      sprintf(value, "%s",ptr);
      WEBconf.sec = atoi(value);
    }
    ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"key");
    if(ptr) {
      sprintf(WEBconf.key, "%s",ptr);
    }
	ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"cm");
    if(ptr) {
	  sprintf(value, "%s",ptr);
      if(atoi(value)==1) {  //SETUP LAN
		WEBcmd=1;
      } else if(atoi(value)==2){  //SETUP WIFI
	    WEBcmd=2;
	  } else if(atoi(value)==3){  //REBOOT
	    WEBcmd=3;
	  } else if((atoi(value)>=10) && (atoi(value)<=15)) {  //COMANDO RELE'
		output = output  ^ (0x01 << (atoi(value)-10));
		WEBcmd=10;
	  }
    }
  }
  return HTTP_IO_DONE;
}


#ifdef HTTP_USE_POST
/****************************************************************************
  FUNCTION	HTTP_IO_RESULT HTTPExecutePost(void)
	
  This function processes every POST request from the pages. 
*****************************************************************************/
HTTP_IO_RESULT HTTPExecutePost(void)
{

	
	return HTTP_IO_DONE;
}
#endif

void IpToString(IP_ADDR IPVal, char *IP){
  BYTE IPDigit[4];
  BYTE j,i,IPpos;
  IPpos=0;
  for(i=0; i < sizeof(IP_ADDR); i++) {
    uitoa((WORD)IPVal.v[i], IPDigit);	
	for(j = 0; j < strlen((char*)IPDigit); j++) {
	   IP[IPpos++] = IPDigit[j];
	}
	if(i == sizeof(IP_ADDR)-1) break;
	IP[IPpos++] = '.'; 
  }
  IP[IPpos++] = 0;
}



void HTTPPrint_json(WORD num){
  char value[20];
  if(num){
	  
	
	//sprintf(value,"%d",WFConf[0].MyMACAddr.v[0]);
	//UARTWrite(1,value);
	
    TCPPutROMString(sktHTTP, "{\"ROOT\": [ \
    {\"FIRMWARE\": [{\"ver\": \"");
	TCPPutROMString(sktHTTP, app_ver);
	TCPPutROMString(sktHTTP, "\", \"date\": \"");
	TCPPutROMString(sktHTTP, app_date);
	TCPPutROMString(sktHTTP, "\"}]}, \
    {\"HOME\": [{\"temperature\": \"");
    sprintf(value,"%.02f", temperature);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"input\": \"");
    sprintf(value,"%lu", input);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"output\": \"");
    sprintf(value,"%d", output);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\"}]}, \
    {\"LAN\": [{\"ip\": \"");
    IpToString(WFConf[0].MyIPAddr, value);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"nm\": \"");
    IpToString(WFConf[0].MyMask, value);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"gw\": \"");
    IpToString(WFConf[0].MyGateway, value);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"mac\": \"");
    sprintf(value,"%02X:%02X:%02X:%02X:%02X:%02X", WFConf[0].MyMACAddr.v[0],WFConf[0].MyMACAddr.v[1],WFConf[0].MyMACAddr.v[2],WFConf[0].MyMACAddr.v[3],WFConf[0].MyMACAddr.v[4],WFConf[0].MyMACAddr.v[5]);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\"}]}, \
    {\"WIFI\": [{\"ssid\": \"");
    TCPPutROMString(sktHTTP, WFConf[0].MySSID);
    TCPPutROMString(sktHTTP,"\", \"mode\": \"");
    sprintf(value,"%d",WFConf[0].networkType);
    TCPPutROMString(sktHTTP, value);
    TCPPutROMString(sktHTTP,"\", \"sec\": \"");
    sprintf(value,"%d",WFConf[0].SecurityMode);
    TCPPutROMString(sktHTTP, value);
	TCPPutROMString(sktHTTP,"\", \"key\": \"");
	TCPPutROMString(sktHTTP, WFConf[0].SecurityKey);
	TCPPutROMString(sktHTTP,"\"}]},]}");

  } else { //Json solo temperatura ed umidità

  }
  return; 
}








#endif
